ad_page_contract {
    serve the correct template based from what is template assigned
    on the cms_context of public
} {
}

set root_id [bcms::folder::get_bcms_root_folder]
set root_url [ad_conn package_url]
set extra_url [ad_conn extra_url]
if [string equal $extra_url ""] {set extra_url "/"}

set manage_type [ad_get_client_property -default content [ad_conn package_id] manage_type]
if {[string equal $manage_type "template"]} {
    #if we are on template manage_type then we need to use the template folder not the page folder
    set root_id [parameter::get -parameter template_folder_id]
}

# get the item by url
array set current_item [bcms::item::get_item_by_url -root_id $root_id -url "$extra_url" -revision live -resolve_index]

# check to see if there is a content item for this url.
# array size 1 there is no live item in this url
# array size 0 there is no item in this url
if {[array size current_item] > 1} {

    # lets check if we need to have / on the url
    # if the item is index but the last urlv is not index or the url does not have / on the end
    # we need to redirect.
    set current_url_list [ad_conn urlv]
    set current_url [ad_conn url]
    if {![string equal [lindex  $current_url_list end] "index"] \
            && ![regexp {/$} $current_url] \
            && [string equal $current_item(name) "index"]} {
        ad_returnredirect "$current_url/"
        ad_script_abort
    }

    if {![string equal $current_item(storage_type) "text"]} {
        cr_write_content -revision_id $current_item(live_revision)
        ad_script_abort
    }

    # get the template for this item
    array set one_template [bcms::template::get_template -item_id $current_item(item_id) -context public]

    if {[array size one_template] > 0} {
        ad_return_template /templates/public/$one_template(name)
    } else {
        array set one_template [bcms::template::get_template -item_id $current_item(parent_id) -context public]
        if {[array size one_template] > 0} {
            ad_return_template /templates/public/$one_template(name)
        }
    }
    
} else {
    if {([array size current_item] > 0) && [permission::permission_p -object_id [ad_conn package_id] -privilege admin]} {
        # lets check if there is an item, but its not published
        # lets redirect to switch context
        # check the permission if user has permission for the package
        ad_returnredirect [bcms::ui::base::switch_cms_context_url -cms_context bcms-ui-base]
        ad_script_abort
    } else {
        ns_returnnotfound
        ad_script_abort
    }
}

